/**
 * Copyright (c) 2024-2025 National Fundamental Software of China Co., Ltd.
 * 
 * You should have find a copy of NFSChina License. If not, please contact us 
 * by email <os_support@nfschina.com>  
 * 
**/
#include <linux/kernel.h>
#include <linux/module.h>
#include <linux/fs.h>
#include <linux/init.h>
#include <linux/mount.h>
#include <linux/lsm_hooks.h>
#include "security_ops.h"
int test_sb_mount(const char *dev_name, const struct path *path, const char *type, unsigned long flags, void *data)
{
    pr_alert("This is a test, in test hook :test_sb_mount()\n");
    pr_alert("%s mounted at %s\n", dev_name?dev_name:"none",path->dentry->d_iname);
    return 0;
}

int test_sb_umount(struct vfsmount *mnt, int flags)
{
    pr_alert("This is a test, in test hook :test_sb_umount()\n");
    pr_alert("%s umounted\n", mnt->mnt_root->d_iname);
    return 0;
}

static struct security_operations test_ops = {
    .name = "test",
    .sb_mount = test_sb_mount,
    .sb_umount= test_sb_umount
};

static int test_init(void)
{
    int ret;
    ret = security_add_external_ops(&test_ops);
    if (ret < 0) {
        return ret;
    }
    return 0;
}

static void test_exit(void)
{
    security_del_external_ops(&test_ops);
}

module_init(test_init);
module_exit(test_exit);
